function getMaxSMSCharacters(mode)
{
/*var max_sms_length=160;
//from cell_private.h
switch (mode)
{
default:
case "ascii7":
max_sms_length=160;
break;
case "ascii8":
max_sms_length=140;
break;
case "ucs-2":
max_sms_length=70;
break;
}
return max_sms_length;*/
//why do you want to send a large test SMS?
return 2048;
}
function checkSMS()
{
var msg=document.getElementById("testmessage");
var mode=document.getElementById("testmode");
var max_sms_length=getMaxSMSCharacters(mode.value);
var is_warning=false;

if(mode.value=="ascii7")
{
var gsm = "@£$¥èéùìòÇØøÅåΔ_ΦΓΛΩΠΨΣΘΞ^{}\[~]|€ÆæßÉ !\"#¤%&'()*+,-./0123456789:;<=>?¡ABCDEFGHIJKLMNOPQRSTUVWXYZÄÖÑÜ§¿abcdefghijklmnopqrstuvwxyzäöñüà";
for (var i = 0; i < msg.value.length; i++)
{
letter = msg.value[i];
var is_valid = gsm.indexOf(letter) !== -1;
if(!is_valid && !is_warning)
{
is_warning=true;
}
}
}
if (msg.value.length>max_sms_length)
{
msg.value=msg.value.substring(0,max_sms_length)
}
document.getElementById("remaining_characters").innerHTML=max_sms_length-msg.value.length;
if(is_warning)
{
var warning="&nbsp;<b style='color:red'>(One or more characters are not valid for the selected mode.)</b>";
document.getElementById("remaining_characters").innerHTML += warning;
}
}
function SetSMSDisplay(xml)
{
SetSubmit(false);
if(xml)
{
var nav1=GetXmlData(xml,"nav1");
var nav2=GetXmlData(xml,"nav2");
if(nav1=="inbound")HighlightElementInTable('smsNav1', 'smsInbound');
else HighlightElementInTable('smsNav1', 'smsOutbound');
if(nav2=="statistics")HighlightElementInTable('smsNav2', 'smsStatistics');
else HighlightElementInTable('smsNav2', 'smsConfiguration');
}
var msg=document.getElementById("testmessage");
var mode=document.getElementById("testmode");
var remaining_chars=document.getElementById("remaining_characters")
if(msg && mode && remaining_chars)
{
var max_sms_length=getMaxSMSCharacters(mode.value);
remaining_chars.innerHTML=max_sms_length;
}
}

function SetOutboundServerDisplay(xml)
{
displayElementRootNames = new Array();
SetSubmit(false);
SetDisplaySelection('Sms_Outbound.Channel');
SetDisplaySelection('Sms_Outbound.Message_Center_Override_Number');
document.getElementById("smsoutboundform").style.display = "block";
}

function inboundSMSStatus(xml)
{
var r = '';
var s="";
r = "<table class='basicTable'>";
r += "<tr class='statusHeader'><td>Sender</td><td>Message Timestamp</td><td>Content</td></tr>";
var logCount=0;
if(! xml || ! xml.hasChildNodes())
{
}
else
{
for(var i = 0; xml && i < xml.childNodes.length; ++i)
{
var log = xml.childNodes[i];
if(log.nodeName.toLowerCase() == "log")
{
logCount++;
s += "<tr>";
s += "<td>"+GetXmlData(log,"sender")+"</td>";
s += "<td>"+GetXmlData(log,"time")+"</td>";
s += "<td><textarea style='border:none;resize:none' cols='16' readonly>"+GetXmlData(log,"content")+"</textarea></td>";
s += "</tr>";
}
}
}
if(logCount==0)
{
s = "<tr><td colspan='4'><i>No records are available</i></td></tr>";
}
r += s;
r += '</table>';
var d = document.getElementById('status');
d.innerHTML=r;
}

function outboundSMSStatus(xml)
{
var r = '';
var s="";
r = "<table class='basicTable'>";
r += "<tr class='statusHeader'><td>To</td><td>Time Sent</td><td>Status/Attempts</td><td>Content</td></tr>";
var logCount=0;
if(! xml || ! xml.hasChildNodes())
{
}
else
{
for(var i = 0; xml && i < xml.childNodes.length; ++i)
{
var log = xml.childNodes[i];
if(log.nodeName.toLowerCase() == "log")
{
logCount++;
s += "<tr>";
s += "<td>"+GetXmlData(log,"to")+"</td>";
s += "<td>"+GetXmlData(log,"time")+"</td>";
s += "<td>"+GetXmlData(log,"status")+"</td>";
s += "<td><textarea style='border:none;resize:none' cols='16' readonly>"+GetXmlData(log,"content")+"</textarea></td>";
s += "</tr>";
}
}
}
if(logCount==0)
{
s = "<tr><td colspan='4'><i>No records are available</i></td></tr>";
}
r += s;
r += '</table>';
var d = document.getElementById('status');
d.innerHTML=r;
}

function updateTunnelSelection(identifier)
{
var smsTunnelId="smstunnel." + identifier;
var d = document.getElementById(smsTunnelId);
var smsLineId="smsline." + identifier;
var e = document.getElementById(smsLineId);
if(d && e)
{
//e.style.display=d.checked?"":"none";
}
}
function inboundSMSConfigRender(xml)
{
var numSerialPorts = GetXmlData(xml, "numSerialPorts");
var d = document.getElementById("smsLine_selection");
if(d)
{
var r = "";
r+="<select name=\"smsLine\" >";
r+="<option value=\"All\">All</option>";
for(var i = 0;i<numSerialPorts;++i)
{
r += "<option value='Line " + (i+1) + "' " + ">Line " + (i+1) +" </option>";
}
r+="</select>";
d.innerHTML = r;
}
var numEntries = GetXmlData(xml, "numEntries");
for(var i=0;i<numEntries;i++)
{
updateTunnelSelection(i);
}
}

function inboundSMSConfig(xml)
{
var r = '';
r = "<table class='basicTable'>";
var cols=3;
r += "<tr class='statusHeader'><td>Delete</td><td>Number</td><td>Shoulder Tap</td>";

r += "<td>Relay Control</td>";
cols++;


r += "<td>SMS Tunnel / Transmit Line</td>";
cols++;
var numSerialPorts = GetXmlData(xml, "numSerialPorts");

r += "</tr>";
var whitelistCount=0;
var s="";
if(! xml || ! xml.hasChildNodes())
{
}
else
{
for(var i = 0; xml && i < xml.childNodes.length; ++i)
{
var entry = xml.childNodes[i];
if(entry.nodeName.toLowerCase() == "entry")
{
whitelistCount++;
var identifier=GetXmlData(entry,"index");
var number=GetXmlData(entry,"number");
var shouldertap=GetXmlData(entry,"shouldertap");
s += "<tr>";
s += "<td>";
s += "<input type='checkbox' ";
s += "onclick='updateButtonVisibilities(\"frmInboundSMS\",\"submit_changes\",\"cancel_changes\");' name='delete." + identifier +"' id='delete." + identifier +"' org_state='false'/>";
s += "</td>";

s += "<td>"+number+"</td>";

s += "<td>";
s += "<input type='checkbox' ";
s += "onclick='updateButtonVisibilities(\"frmInboundSMS\",\"submit_changes\",\"cancel_changes\");' name='shouldertap." + identifier +"' id='shouldertap." + identifier +"' org_state='"+shouldertap+"' ";
if(shouldertap=="true")s += " checked ";
s += "/>";
s += "</td>";

var relaycontrol=GetXmlData(entry,"relaycontrol");
s += "<td>";
s += "<input type='checkbox' ";
s += "onclick='updateButtonVisibilities(\"frmInboundSMS\",\"submit_changes\",\"cancel_changes\");' name='relaycontrol." + identifier +"' id='relaycontrol." + identifier +"' org_state='"+relaycontrol+"' ";
if(relaycontrol=="true")s += " checked ";
s += "/>";
s += "</td>";


var smstunnel=GetXmlData(entry,"smstunnel");
var smsline=GetXmlData(entry,"smsline");
s += "<td>";
s += "<input type='checkbox' ";
s += "onclick='updateTunnelSelection("+identifier+");updateButtonVisibilities(\"frmInboundSMS\",\"submit_changes\",\"cancel_changes\");' name='smstunnel." + identifier +"' id='smstunnel." + identifier +"' org_state='"+smstunnel+"' ";
if(smstunnel=="true")s += " checked ";
s += "/></br>";
s+="<select name='smsline."+identifier+"' id='smsline."+identifier+"' org_value='"+smsline+"' onchange='updateButtonVisibilities(\"frmInboundSMS\",\"submit_changes\",\"cancel_changes\");'>";
s+="<option value=\"All\"";
if(smsline=="All")s+=" selected ";
s+=">All</option>";
for(var j = 0;j<numSerialPorts;++j)
{
var thisLine="Line "+(j+1);
s += "<option value='Line " + (j+1) + "' ";
if(smsline==thisLine)s+=" selected "
s += ">Line " + (j+1) +" </option>";
}
s+="</select>";
s += "</td>";

s += "</tr>";
}
}
}
if(whitelistCount==0)
{
s = "<tr><td colspan='"+cols+"'><i>Empty</i></td></tr>";
}
r += s;
r += '</table>';
var d = document.getElementById('inboundSMS');
d.innerHTML=r;
updateButtonVisibilities('frmInboundSMS','submit_changes','cancel_changes');
}
